/*
    MSGLIB - a message handling library
    Copyright (C) 1995,1997  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/*
    utility for the message handling library
    Copyright (C) 1995  Steffen Kaiser

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*/
/* $RCSfile: MSGLIB.C $
   $Locker:  $	$Name:  $	$State: Exp $

	Generate linker a response file from a file list.

	Usage: msgLib [{file}...] >responseFile

	If file is omitted, stdin is read.
	The file is a whitespace delimited list of object files,
	msgLib creates a librarian response file.

	There will be no error reporting at all.

*/

#include <stdio.h>
#ifndef _MICROC_
#include <string.h>
#endif
#include <freedos.h>

#ifndef lint
static char const rcsid[] = 
	"$Id: MSGLIB.C 1.1 1998/01/14 08:31:59 ska Exp $";
#endif

#define BUF 4096
char buf[BUF];
char o[BUF] = "";

void handle(FILE *fin)
{	char *s;

	while(fgets(buf, BUF, fin))
		if(s = strtok(buf, " \t\n")) do {
			if(*s) {
				stpcpy(stpcat(o, "+ "), s);
				fputs(o, stdout);	/* NO \n !!! */
				stpcpy(o, " &\n");
			}
		} while(s = strtok(NULL, " \t\n"));
}

int main(int argc, char **argv)
{	FILE *fp;

	if(argc == 1)	/* clean up from stdin */
		handle(stdin);
	else while(*++argv)
		if(fp = fopen(*argv, "rt")) {
			handle(fp);
			fclose(fp);
		}

	putchar('\n');
#ifndef _MICROC_
	return 0;
#endif
}

